#include <ESP8266WiFi.h>
#include <WiFiClient.h> 
#include <ESP8266HTTPClient.h>
#include <ArduinoJson.h>

const char* wifiName = ""; // SSID
const char* wifiPass = ""; // PASSWORD

//Web Server address to read/write from 
const char *host = "https://YourDomin.ir/espTel/status.json"; // آدرس محل قرارگیری فایل جیسون

int music=0,kitchen=0,TV=0,TVroom=0,bedroom=0;
void setup() {

  pinMode(D0,OUTPUT);
  pinMode(D1,OUTPUT);
  pinMode(D2,OUTPUT);
  pinMode(D3,OUTPUT);
  pinMode(D4,OUTPUT);
  
  Serial.begin(115200);
  delay(10);
  Serial.println();
  
  Serial.print("Connecting to ");
  Serial.println(wifiName);

  WiFi.begin(wifiName, wifiPass);

  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }

  Serial.println("");
  Serial.println("WiFi connected");
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());   //You can get IP address assigned to ESP
}

void loop() {
  HTTPClient http;    //Declare object of class HTTPClient

  Serial.print("Request Link:");
  Serial.println(host);
  
  http.begin(host);     //Specify request destination
  
  int httpCode = http.GET();            //Send the request
  String payload = http.getString();    //Get the response payload from server

  Serial.print("Response Code:"); //200 is OK
  Serial.println(httpCode);   //Print HTTP return code

  Serial.print("Returned data from Server:");
  Serial.println(payload);    //Print request response payload
  
  if(httpCode == 200)
  {
    // Allocate JsonBuffer
    // Use arduinojson.org/assistant to compute the capacity.
    const size_t capacity = JSON_OBJECT_SIZE(3) + JSON_ARRAY_SIZE(2) + 60;
    DynamicJsonDocument jsonBuffer(capacity);
  
   // Parse JSON object
   StaticJsonDocument<1024> root;
   deserializeJson( root, payload);
    
    if( root["music"].as<int>() == 1 ) music=1; else music=0;
    if( root["kitchen"].as<int>() == 1 ) kitchen=1; else kitchen=0;
    if( root["TV"].as<int>() == 1 ) TV=1; else TV=0;
    if( root["TVroom"].as<int>() == 1 ) TVroom=1; else TVroom=0;
    if( root["bedroom"].as<int>() == 1 ) bedroom=1; else bedroom=0;

    digitalWrite(D0,music);
    digitalWrite(D1,kitchen);
    digitalWrite(D2,TV); 
    digitalWrite(D3,TVroom); 
    digitalWrite(D4,bedroom);    
  }
  else
  {
    Serial.println("Error in response");
  }

  http.end();  //Close connection
  
  delay(2000);  //GET Data at every 5 seconds
}


/* الک لرن | آموزش تخصصی الکترونیک دیجیتال
 *  
 *  https://www.elec-learn.ir
 *  https://www.elec-learn.ir
 *  https://www.elec-learn.ir
 *  
 *  instagram : @elec_learn
 */
